;#########################################################
;##                                                     ##
;##      VDRLive ISO Customizer - By VDRLive Team       ##
;##                                                     ##
;#########################################################

!define NAME "VDRLive ISO Customizer"
!define FILENAME "VDRLive_ISO_Customizer"

ReserveFile "${NSISDIR}\Plugins\InstallOptions.dll"
ReserveFile "${NSISDIR}\Plugins\AdvSplash.dll"
ReserveFile "Temp_dev\Iso.ini"

ShowInstDetails show

Name "${NAME}"
Caption "${NAME}"
BrandingText "By VDRLive Team"
OutFile "${FILENAME}.exe"
Icon "Temp_dev\VDRLive0.ico"
SetFont "arial" 9
XPStyle on
AddBrandingImage left 100
InstallColors 000055 FFFFFF
LicenseBkColor FFFFFF

SubCaption 0 " "
SubCaption 1 " "
SubCaption 3 " "
SubCaption 4 " "
SpaceTexts none

Page components
Page custom SetIso 
Page instfiles

InstType "Extraction d'une image ISO"
InstType "Cration d'une image ISO"
InstType /NOCUSTOM
InstType /COMPONENTSONLYONCUSTOM

ComponentText "Choisissez ce que vous voulez faire:" " " " "
InstallButtonText "Dmarrer"


;############################################################################

Section ""
SectionIn 1 2

Setdetailsprint none

Banner::show /NOUNLOAD "Oprations en cours, veuillez patienter..."

!define TEMP1           $0
!define CMD             $1
!define ISO_originale   $2
!define ISO_finale      $3

ReadINIStr ${ISO_originale} "$EXEDIR\Temp\Iso.ini" "Field 2" "State"
ClearErrors

                StrCmp "${ISO_finale}" "" rep_final_no rep_final_yes
                rep_final_no:
                StrCpy "${ISO_finale}" "$EXEDIR"
  		rep_final_yes:
  		
  		StrCmp "${ISO_originale}" "${ISO_finale}\VDRLive-Custom.iso" rename_iso_yes rename_iso_no 
  		rename_iso_yes:
  		Rename "${ISO_originale}" "${ISO_finale}\VDRLive-Custom-Old.iso"
  		StrCpy "${ISO_originale}" "${ISO_finale}\VDRLive-Custom-Old.iso"
  		rename_iso_no:
  	
                Delete "${ISO_finale}\VDRLive-Custom.iso"
  		
SectionEnd

;############################################################################

SubSection "Extraction de l'iso"

Section "Dcompilation de l'iso originale"
SectionIn 1

    Setdetailsprint both
    DetailPrint "--------------------------------------------------"
    DetailPrint "Dcompilation de l'iso originale ..."
    
    IfFileExists "${ISO_originale}" iso_ok
    Banner::destroy
    Setdetailsview show
    DetailPrint "Fichier iso introuvable !"
    DetailPrint "Vous devez slectionner une image iso sur la page prcdente."
    Abort "Impossible de continuer !!!"
    iso_ok:
    
    Setdetailsprint none
    ClearErrors
    CreateDirectory $EXEDIR\ARBRE_Modifiee_Compresse

    nsExec::Exec '${CMD} /c "$EXEDIR\Temp\miso ${ISO_originale} -x $EXEDIR\ARBRE_Modifiee_Compresse\ > NULL"'

    IntCmp ${TEMP1} 0 decompilation_ok
    Goto decompilation_err

		decompilation_err:
		Setdetailsprint both
    		DetailPrint "Erreur !"
    		Setdetailsprint none
    		Banner::destroy
                Setdetailsview show
    		Abort

		decompilation_ok:
		Setdetailsprint both
		DetailPrint "Succs."
		DetailPrint "--------------------------------------------------"
		Setdetailsprint none

SectionEnd

;############################################################################

Section "Dcompression des fichiers"
SectionIn 1

    Setdetailsprint both
    DetailPrint "--------------------------------------------------"
    DetailPrint "Dcompression des fichiers ..."
    
    IfFileExists "$EXEDIR\ARBRE_Modifiee_Compresse" rep_AMC_ok
    Banner::destroy
    Setdetailsview show
    DetailPrint "Rpertoire 'ARBRE_Modifiee_Compresse' introuvable !"
    DetailPrint "La dcompilation de l'iso ne s'est pas termine normalement."
    Abort "Impossible de continuer !!!"
    rep_AMC_ok:
    
    Setdetailsprint none
    ClearErrors
    
    nsExec::Exec '${CMD} /c "$EXEDIR\Temp\mkzftree -u $EXEDIR\ARBRE_Modifiee_Compresse\ $EXEDIR\ARBRE_Modifiee > NULL"'

    IntCmp ${TEMP1} 0 decompression_ok
    Goto decompression_err

		decompression_err:
		Setdetailsprint both
    		DetailPrint "Erreur !"
    		Setdetailsprint none
    		Banner::destroy
                Setdetailsview show
    		Abort
	
		decompression_ok: 
                RMDir /r "$EXEDIR\ARBRE_Modifiee_Compresse"
                Setdetailsprint both
		DetailPrint "Succs."
		DetailPrint "--------------------------------------------------"
		Setdetailsprint none

SectionEnd

SubSectionEnd

;############################################################################

SubSection "Cration de l'iso"

Section "Compression des fichiers"
SectionIn 2
    
    Setdetailsprint both
    DetailPrint "--------------------------------------------------"
    DetailPrint "Compression des fichiers ..."
    
    IfFileExists "$EXEDIR\ARBRE_Modifiee" rep_AM_ok
    Banner::destroy
    Setdetailsview show
    DetailPrint "Rpertoire 'ARBRE_Modifiee' introuvable !"
    DetailPrint "Vous devez avoir effectu une extraction d'iso avant cette tape."
    Abort "Impossible de continuer !!!"
    rep_AM_ok:
    
    Setdetailsprint none
    ClearErrors
    
    nsExec::Exec '${CMD} /c "$EXEDIR\Temp\mkzftree $EXEDIR\ARBRE_Modifiee $EXEDIR\ARBRE_Modifiee_Compresse > NULL"'
    
    RMDir /r "$EXEDIR\ARBRE_Modifiee_Compresse\VDRLive\aide"
    Rename "$EXEDIR\ARBRE_Modifiee\VDRLive\aide" "$EXEDIR\ARBRE_Modifiee_Compresse\VDRLive\aide"
    RMDir /r "$EXEDIR\ARBRE_Modifiee_Compresse\VDRLive\boot"
    Rename "$EXEDIR\ARBRE_Modifiee\VDRLive\boot" "$EXEDIR\ARBRE_Modifiee_Compresse\VDRLive\boot"
    RMDir /r "$EXEDIR\ARBRE_Modifiee_Compresse\VDRLive\etc"
    Rename "$EXEDIR\ARBRE_Modifiee\VDRLive\etc" "$EXEDIR\ARBRE_Modifiee_Compresse\VDRLive\etc"
    RMDir /r "$EXEDIR\ARBRE_Modifiee_Compresse\VDRLive\sbin"
    Rename "$EXEDIR\ARBRE_Modifiee\VDRLive\sbin" "$EXEDIR\ARBRE_Modifiee_Compresse\VDRLive\sbin"
    RMDir /r "$EXEDIR\ARBRE_Modifiee_Compresse\VDRLive\video"
    Rename "$EXEDIR\ARBRE_Modifiee\VDRLive\video" "$EXEDIR\ARBRE_Modifiee_Compresse\VDRLive\video"

    IntCmp ${TEMP1} 0 recompression_ok
    Goto recompression_err

		recompression_err:
		Setdetailsprint both
    		DetailPrint "Erreur !"
    		Setdetailsprint none
    		Banner::destroy
                Setdetailsview show
    		Abort
	
		recompression_ok:
		RMDir /r "$EXEDIR\ARBRE_Modifiee"
		Setdetailsprint both
		DetailPrint "Succs."
		DetailPrint "--------------------------------------------------"
		Setdetailsprint none

SectionEnd

;############################################################################

Section "Compilation de l'iso personnalise"
SectionIn 2
    
    Setdetailsprint both
    DetailPrint "--------------------------------------------------"
    DetailPrint "Compilation de l'iso personnalise..."
    
    IfFileExists "$EXEDIR\ARBRE_Modifiee_Compresse" rep_AMC_ok
    Banner::destroy
    Setdetailsview show
    DetailPrint "Rpertoire 'ARBRE_Modifiee_Compresse' introuvable !"
    DetailPrint "La compression des fichiers ne s'est pas termine normalement."
    Abort "Impossible de continuer !!!"
    rep_AMC_ok:
    
    Setdetailsprint none
    ClearErrors

    CreateDirectory "$EXEDIR\Temp\ziso"
    Rename "$EXEDIR\ARBRE_Modifiee_Compresse\VDRLive" "$EXEDIR\Temp\ziso\VDRLive"
    nsExec::Exec '${CMD} /c \
    cd $EXEDIR\Temp > NULL && \
    mkisofs -quiet -no-pad -V VDRLive -volset VDRLive -P "VDRLive by the VDRLive Team" -p "VDRLive by the VDRLive Team" -A "MKISOFS ISO 9660/HFS FILESYSTEM BUILDER" -z -f -D -r -J -b VDRLive/boot/isolinux.bin -c VDRLive/boot/boot.catalog -no-emul-boot -boot-load-size 4 -boot-info-table ziso > tmp.iso'

    CopyFiles "$EXEDIR\Temp\tmp.iso" "${ISO_finale}\VDRLive-Custom.iso"

    IntCmp ${TEMP1} 0 recompilation_ok
    Goto recompilation_err

		recompilation_err:
		Setdetailsprint both
    		DetailPrint "Erreur !"
    		Setdetailsprint none
    		Banner::destroy
                Setdetailsview show
    		Abort

		recompilation_ok:
		RMDir /r "$EXEDIR\ARBRE_Modifiee_Compresse"
		Setdetailsprint both
		DetailPrint "Succs."
		DetailPrint "--------------------------------------------------"
		Setdetailsprint none

SectionEnd

SubSectionEnd

;############################################################################

Section ""
SectionIn 1 2

          Banner::destroy
          Delete "${ISO_finale}\NULL"
          Delete "$EXEDIR\NULL"
          RMDir /r "$EXEDIR\Temp"
          Setdetailsprint both

          IfFileExists "${ISO_finale}\VDRLive-Custom.iso" iso_yes
            Goto iso_no
          iso_yes:
            Setdetailsview show
            DetailPrint ""
            DetailPrint "--------------------------------------------------------------------------------------"
    	    DetailPrint " Votre image ISO personnalise de la VDRLive est termine."
    	    DetailPrint " Il ne vous reste plus qu' la graver en mode Disk-At-Once."
    	    DetailPrint " "
    	    DetailPrint " L'quipe VDRLive."
    	    DetailPrint " http://vdrlive1.free.fr/PHPNUKE/"
    	    DetailPrint "--------------------------------------------------------------------------------------"
    	    DetailPrint ""
    	    DetailPrint ""
    	    Goto iso_end
    	  iso_no:
    	    Setdetailsview show
            DetailPrint ""
            DetailPrint ""
            DetailPrint "--------------------------------------------------------------------------------------"
    	    DetailPrint " L'extraction de l'iso originale s'est termine avec succs !"
    	    DetailPrint " Vous pouvez dsormais modifier ce que vous dsirez dans le" 
            DetailPrint " rpertoire 'ARBRE_Modifiee' cr  cet effet."
    	    DetailPrint " Une fois toutes vos modifications effectues, relancer ce"
            DetailPrint " logiciel pour crer votre image iso personnalise."
    	    DetailPrint " "
    	    DetailPrint " L'quipe VDRLive."
    	    DetailPrint " http://vdrlive1.free.fr/PHPNUKE/"
    	    DetailPrint "--------------------------------------------------------------------------------------"
          iso_end:
          
SectionEnd

;############################################################################

Function .onInit
    InitPluginsDir
    CreateDirectory "$EXEDIR\Temp"
    File /oname=$EXEDIR\Temp\cygwin1.dll "Temp_dev\cygwin1.dll"
    File /oname=$EXEDIR\Temp\cygwinb19.dll "Temp_dev\cygwinb19.dll"
    File /oname=$EXEDIR\Temp\cygz.dll "Temp_dev\cygz.dll"
    File /oname=$EXEDIR\Temp\miso.exe "Temp_dev\miso.exe"
    File /oname=$EXEDIR\Temp\mkisofs.exe "Temp_dev\mkisofs.exe"
    File /oname=$EXEDIR\Temp\mkzftree.exe "Temp_dev\mkzftree.exe"
    SetOverwrite off
    File /oname=$EXEDIR\Temp\Iso.ini "Temp_dev\Iso.ini"
    SetOverwrite on
    
    SetOutPath "$EXEDIR"
    
    ReadRegStr $R0 HKLM "SOFTWARE\Microsoft\Windows NT\CurrentVersion" CurrentVersion
    StrCmp $R0 "" 0 cmd_winnt
    StrCpy ${CMD} "command.com"
    Goto cmd_cont
    cmd_winnt:
    StrCpy ${CMD} "cmd.exe"
    cmd_cont:
FunctionEnd

;############################################################################

Function .onGUIInit
        !macro BIMAGE IMAGE PARMS
	Push $0
	GetTempFileName $0
	File /oname=$0 "${IMAGE}"
	SetBrandingImage ${PARMS} $0
	Delete $0
	Pop $0
        !macroend
        !insertmacro BIMAGE "Temp_dev\VDRLive2.bmp"  ""
FunctionEnd

Function SetIso
        GetCurInstType $5
        StrCmp "$5" "0" set_iso_yes set_iso_no
        set_iso_yes:
        InstallOptions::Dialog "$EXEDIR\Temp\Iso.ini"
        set_iso_no:
        Abort
FunctionEnd

;############################################################################

Function .onGUIEnd
	Banner::destroy
        Delete "${ISO_finale}\NULL"
        Delete "$EXEDIR\NULL"
        RMDir /r "$EXEDIR\Temp"
FunctionEnd

;############################################################################
